-- name: Star Revenge 0.5: Unused Levels
-- description: Romhack made by BroDute, Ported by BlackJoystick. \n \n This is the 0.5th Star Revenge Hack, contains 67 Stars. \n \nSpecial Thanks to Blocky.png for helping me solve out an issue in Course 7.
-- incompatible: romhack

gLevelValues.entryLevel = LEVEL_CASTLE_GROUNDS

gServerSettings.skipIntro = 1

gBehaviorValues.trajectories.KoopaBobTrajectory = get_trajectory('KoopaBoB_path')
gBehaviorValues.trajectories.KoopaThiTrajectory = get_trajectory('KoopaTHI_path')
gBehaviorValues.trajectories.PlatformRrTrajectory          = get_trajectory('rr_seg7_trajectory_0702EC3C_RM2C_path')
gBehaviorValues.trajectories.PlatformRr2Trajectory         = get_trajectory('rr_seg7_trajectory_0702ECC0_RM2C_path')
gBehaviorValues.trajectories.PlatformCcmTrajectory         = get_trajectory('ccm_seg7_trajectory_0701669C_RM2C_path')
gBehaviorValues.trajectories.PlatformBitfsTrajectory       = get_trajectory('bitfs_seg7_trajectory_070159AC_RM2C_path')
gBehaviorValues.trajectories.PlatformHmcTrajectory         = get_trajectory('hmc_seg7_trajectory_0702B86C_RM2C_path')
gBehaviorValues.trajectories.PlatformLllTrajectory         = get_trajectory('lll_seg7_trajectory_0702856C_RM2C_path')
gBehaviorValues.trajectories.PlatformLll2Trajectory        = get_trajectory('lll_seg7_trajectory_07028660_RM2C_path')
gBehaviorValues.trajectories.PlatformRr3Trajectory         = get_trajectory('rr_seg7_trajectory_0702ED9C_RM2C_path')
gBehaviorValues.trajectories.PlatformRr4Trajectory         = get_trajectory('rr_seg7_trajectory_0702EEE0_RM2C_path')
gBehaviorValues.trajectories.RacingPenguinTrajectory       = get_trajectory('ccm_seg7_trajectory_penguin_race_RM2C_path')
gBehaviorValues.trajectories.BowlingBallBobTrajectory      = get_trajectory('ttc_bowling_ball_path')
gBehaviorValues.trajectories.BowlingBallThiLargeTrajectory = get_trajectory('rr_bowling_ball_path')

gLevelValues.floorLowerLimit = -32767

camera_set_use_course_specific_settings(false)

smlua_audio_utils_replace_sequence(0x01, 0x22, 75, "01_Seq_custom")
smlua_audio_utils_replace_sequence(0x02, 0x25, 75, "02_Seq_custom")
smlua_audio_utils_replace_sequence(0x04, 0x25, 75, "04_Seq_custom")
smlua_audio_utils_replace_sequence(0x05, 0x11, 75, "05_Seq_custom")
smlua_audio_utils_replace_sequence(0x06, 0x1A, 75, "06_Seq_custom")
smlua_audio_utils_replace_sequence(0x08, 0x25, 75, "08_Seq_custom")
smlua_audio_utils_replace_sequence(0x09, 0x19, 75, "09_Seq_custom")
smlua_audio_utils_replace_sequence(0x09, 0x19, 75, "09_Seq_custom")
smlua_audio_utils_replace_sequence(0x0B, 0x14, 75, "0B_Seq_custom")
smlua_audio_utils_replace_sequence(0x0C, 0x25, 75, "0C_Seq_custom")
smlua_audio_utils_replace_sequence(0x0D, 0x11, 75, "0D_Seq_custom")
smlua_audio_utils_replace_sequence(0x0E, 0x11, 75, "0E_Seq_custom")
smlua_audio_utils_replace_sequence(0x0F, 0x18, 75, "0F_Seq_custom")
smlua_audio_utils_replace_sequence(0x10, 0x1A, 75, "10_Seq_custom")
smlua_audio_utils_replace_sequence(0x12, 0x1A, 75, "12_Seq_custom")
smlua_audio_utils_replace_sequence(0x14, 0x1A, 75, "14_Seq_custom")
smlua_audio_utils_replace_sequence(0x15, 0x0E, 75, "15_Seq_custom")
smlua_audio_utils_replace_sequence(0x16, 0x1A, 75, "16_Seq_custom")
smlua_audio_utils_replace_sequence(0x17, 0x25, 75, "17_Seq_custom")
smlua_audio_utils_replace_sequence(0x1B, 0x14, 75, "1B_Seq_custom")
smlua_audio_utils_replace_sequence(0x1C, 0x20, 75, "1C_Seq_custom")
smlua_audio_utils_replace_sequence(0x1D, 0x1E, 75, "1D_Seq_custom")
smlua_audio_utils_replace_sequence(0x1E, 0x1B, 75, "1E_Seq_custom")
smlua_audio_utils_replace_sequence(0x1F, 0x1A, 75, "1F_Seq_custom")
smlua_audio_utils_replace_sequence(0x20, 0x23, 75, "20_Seq_custom")
smlua_audio_utils_replace_sequence(0x21, 0x0E, 75, "21_Seq_custom")
smlua_audio_utils_replace_sequence(0x23, 0x11, 75, "23_Seq_custom")
smlua_audio_utils_replace_sequence(0x24, 0x11, 75, "24_Seq_custom")
smlua_audio_utils_replace_sequence(0x25, 0x25, 75, "25_Seq_custom")
smlua_audio_utils_replace_sequence(0x26, 0x25, 75, "26_Seq_custom")
smlua_audio_utils_replace_sequence(0x27, 0x17, 75, "27_Seq_custom")
smlua_audio_utils_replace_sequence(0x28, 0x21, 75, "28_Seq_custom")
smlua_audio_utils_replace_sequence(0x29, 0x19, 75, "29_Seq_custom")
smlua_audio_utils_replace_sequence(0x2A, 0x25, 75, "2A_Seq_custom")

vec3f_set(gLevelValues.starPositions.KoopaBobStarPos, -3204, -2012, -4466)
vec3f_set(gLevelValues.starPositions.KoopaThiStarPos, -3204, -2012, -4466)
vec3f_set(gLevelValues.starPositions.KingBobombStarPos, 0.0, 1200.0, 0.0)
vec3f_set(gLevelValues.starPositions.KingWhompStarPos, -2536.0, 4531.0, 160.0)
vec3f_set(gLevelValues.starPositions.EyerockStarPos, 0.0, -900.0, -3700.0)
vec3f_set(gLevelValues.starPositions.BigBullyStarPos, 8489.0, -5138.0, 9857.0)
vec3f_set(gLevelValues.starPositions.ChillBullyStarPos, 8489.0, -5138.0, 9857.0)
vec3f_set(gLevelValues.starPositions.BigPiranhasStarPos, -6300.0, -1850.0, -6300.0)
vec3f_set(gLevelValues.starPositions.TuxieMotherStarPos, -5917.0, 617.0, -8742.0)
vec3f_set(gLevelValues.starPositions.WigglerStarPos, 2981.0, -1570.0, -7832.0)
vec3f_set(gLevelValues.starPositions.PssSlideStarPos, -6358.0, -4300.0, 4700.0)
vec3f_set(gLevelValues.starPositions.RacingPenguinStarPos, -5917.0, 617.0, -8742.0)
vec3f_set(gLevelValues.starPositions.TreasureChestStarPos, -3410.0, -3266.0, -666.0)
vec3f_set(gLevelValues.starPositions.GhostHuntBooStarPos, 980.0, 1100.0, 250.0)
vec3f_set(gLevelValues.starPositions.KleptoStarPos, -5550.0, 300.0, -930.0)
vec3f_set(gLevelValues.starPositions.MerryGoRoundStarPos, 8810.0, 1232.0, 1333.0)
vec3f_set(gLevelValues.starPositions.MrIStarPos, 1370.0, 2000.0, -320.0)
vec3f_set(gLevelValues.starPositions.BalconyBooStarPos, 700.0, 3200.0, 1900.0)
vec3f_set(gLevelValues.starPositions.BigBullyTrioStarPos, -11459.0, -3514.0, -8103.0)

function heal(obj)
    nearest = nearest_mario_state_to_object(obj)
    if (((get_id_from_behavior(obj.behavior) == id_bhv1Up) or (get_id_from_behavior(obj.behavior) == id_bhv1upInPole)) and nearest.playerIndex == 0) then
        gMarioStates[0].health = 0x880
    end
end

hook_event(HOOK_ON_OBJECT_UNLOAD, heal)